#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

struct Globals
{
    float4x4 uVP;
};

struct main0_out
{
    float2 vUV [[user(locn0)]];
    float vAlpha [[user(locn1)]];
    float4 gl_Position [[position]];
};

struct main0_in
{
    float3 aPos [[attribute(0)]];
    float2 aUV [[attribute(1)]];
    float aAlpha [[attribute(2)]];
};

vertex main0_out main0(main0_in in [[stage_in]], constant Globals& _30 [[buffer(0)]])
{
    main0_out out = {};
    out.vUV = in.aUV;
    out.vAlpha = in.aAlpha;
    out.gl_Position = _30.uVP * float4(in.aPos, 1.0);
    out.gl_Position.z = (out.gl_Position.z + out.gl_Position.w) * 0.5;
    return out;
}

